- README

- Top Level Namespace
- Adler32
- ArgumentError
- Array
- Atomic
- Base64
  - Error
- Benchmark
  - BM
    - Job
    - Tms
  - IPS
    - Entry
    - Job
- BigFloat
- BigInt
- BigRational
- BitArray
- Bool
- Box
- Bytes
- Channel
  - Buffered
  - ClosedError
  - ReceiveAction
  - SelectAction
  - SendAction
  - Unbuffered
- Char
  - Reader
- Class
- Colorize
  - Object
  - ObjectExtensions
- Comparable
- Complex
- Concurrent
  - CanceledError
- CRC32
- Crypto
  - Bcrypt
    - Error
    - Password
  - Blowfish
  - Subtle
- Crystal
  - Macros
    - And
    - Arg
    - ArrayLiteral
    - Assign
    - ASTNode
    - BinaryOp
    - Block
    - BoolLiteral
    - Call
    - Case
    - Cast
    - CharLiteral
    - ClassDef
    - ClassVar
    - Def
    - Expressions
    - Generic
    - Global
    - HashLiteral
    - If
    - ImplicitObj
    - InstanceSizeOf
    - InstanceVar
    - IsA
    - Macro
    - MacroId
    - MetaVar
    - MultiAssign
    - NamedArgument
    - NamedTupleLiteral
    - NilableCast
    - NilLiteral
    - Nop
    - Not
    - NumberLiteral
    - Or
    - Out
    - Path
    - PointerOf
    - RangeLiteral
    - ReadInstanceVar
    - RegexLiteral
    - Require
    - RespondsTo
    - SizeOf
    - Splat
    - StringInterpolation
    - StringLiteral
    - SymbolLiteral
    - TupleLiteral
    - TypeDeclaration
    - TypeNode
    - UnaryExpression
    - UninitializedVar
    - Union
    - Var
    - VisibilityModifier
    - When
    - While
  - System
- CSV
  - Builder
    - Row
  - Error
  - Lexer
  - MalformedCSVError
  - Parser
  - Row
  - Token
    - Kind
- Debug
  - DWARF
    - Abbrev
      - Attribute
    - AT
    - FORM
    - Info
      - Value
    - LineNumbers
      - Register
      - Row
      - Sequence
    - LNE
    - LNS
    - Strings
    - TAG
  - ELF
    - Endianness
    - Error
    - Ident
    - Klass
    - Machine
    - OSABI
    - SectionHeader
      - Flags
      - Type
    - Type
- Deque
- Digest
  - Base
  - MD5
  - SHA1
- Dir
- DivisionByZero
- DL
- ECR
- Enum
- Enumerable
  - EmptyError
- ENV
- Errno
- Exception
- Fiber
- File
  - Stat
- FileUtils
- Flate
  - Error
  - Reader
  - Strategy
  - Writer
- Float
  - Primitive
  - Printer
    - CachedPowers
      - Power
    - DiyFP
    - Grisu3
    - IEEE
- Float32
- Float64
- GC
  - Stats
- Gzip
  - Error
  - Header
  - Reader
  - Writer
- Hash
- HTML
- HTTP
  - Client
    - BodyType
    - Response
  - CompressHandler
  - ComputedContentTypeHeader
  - Cookie
  - Cookies
  - ErrorHandler
  - FormData
    - Builder
    - Error
    - FileMetadata
    - Parser
    - Part
  - Handler
    - Proc
  - Headers
  - LogHandler
  - Multipart
    - Builder
    - Error
    - Parser
  - Params
    - Builder
  - Request
  - Server
    - Context
    - RequestProcessor
    - Response
  - StaticFileHandler
    - DirectoryListing
  - WebSocket
  - WebSocketHandler
- Indexable
- IndexError
- INI
- Int
  - Primitive
  - Signed
  - Unsigned
- Int16
- Int32
- Int64
- Int8
- InvalidByteSequenceError
- IO
  - Buffered
  - ByteFormat
    - BigEndian
    - LittleEndian
    - NetworkEndian
    - SystemEndian
  - Delimited
  - EncodingOptions
  - EOFError
  - Error
  - FileDescriptor
  - Hexdump
  - Memory
  - MultiWriter
  - Seek
  - Sized
  - Timeout
- IPSocket
- Iterable
- Iterator
  - IteratorWrapper
  - Stop
- JSON
  - Any
  - Builder
    - ArrayState
    - DocumentEndState
    - DocumentStartState
    - ObjectState
    - StartState
    - State
  - Error
  - Lexer
  - ParseException
  - Parser
  - PullParser
  - Token
  - Type
- KeyError
- Levenshtein
  - Finder
- LLVM
  - ABI
    - AArch64
    - ArgKind
    - ArgType
    - ARM
    - FunctionType
    - X86
    - X86_64
      - RegClass
  - AtomicOrdering
  - AtomicRMWBinOp
  - Attribute
  - AttributeIndex
  - BasicBlock
  - BasicBlockCollection
  - Builder
  - CallConvention
  - CodeGenFileType
  - CodeGenOptLevel
  - CodeModel
  - Context
  - DIBuilder
  - DIFlags
  - DwarfTag
  - DwarfTypeEncoding
  - Function
  - FunctionCollection
  - FunctionPassManager
    - Runner
  - GenericValue
  - GlobalCollection
  - InstructionCollection
  - IntPredicate
  - JITCompiler
  - Linkage
  - MemoryBuffer
  - Module
  - ModuleFlag
  - ModulePassManager
  - OperandBundleDef
  - ParameterCollection
  - PassManagerBuilder
  - PassRegistry
  - PhiTable
  - RealPredicate
  - RelocMode
  - Target
  - TargetData
  - TargetMachine
  - Type
    - Kind
  - Value
    - Kind
  - ValueMethods
  - VerifierFailureAction
- Logger
  - Formatter
  - Severity
- Markdown
  - HTMLRenderer
  - Parser
    - PrefixHeader
    - UnorderedList
  - Renderer
- Math
- Mutex
- NamedTuple
- Nil
- Number
  - Primitive
- OAuth
  - AccessToken
  - Consumer
  - Error
  - RequestToken
- OAuth2
  - AccessToken
    - Bearer
    - Mac
  - Client
  - Error
  - Session
- Object
- OpenSSL
  - Digest
    - Error
    - UnsupportedError
  - DigestBase
  - DigestIO
    - DigestMode
  - Error
  - HMAC
  - MD5
  - SHA1
  - SSL
    - Context
      - Client
      - Server
    - Error
    - ErrorType
    - Modes
    - Options
    - Socket
      - Client
      - Server
    - VerifyMode
    - X509VerifyFlags
- OptionParser
  - Exception
  - InvalidOption
  - MissingOption
- PartialComparable
- Pointer
  - Appender
- PrettyPrint
- Proc
- Process
  - Env
  - Status
  - Stdio
  - Tms
- Random
  - ISAAC
  - MT19937
  - PCG32
  - System
- Range
- Readline
  - CompletionProc
  - KeyBindingProc
- Reference
- Reflect
- Regex
  - MatchData
  - Options
- SecureRandom
- Set
- Signal
- Slice
- Socket
  - Address
  - Addrinfo
  - Error
  - Family
  - IPAddress
  - Protocol
  - Server
  - Type
  - UNIXAddress
- Spec
  - Expectations
  - Methods
  - ObjectExtensions
- StaticArray
- String
  - Builder
  - RawConverter
- StringPool
- StringScanner
- Struct
- Symbol
- System
- TCPServer
- TCPSocket
- Tempfile
- Termios
  - AttributeSelection
  - BaudRate
  - ControlMode
  - InputMode
  - LineControl
  - LocalMode
  - OutputMode
- Time
  - DayOfWeek
  - EpochConverter
  - EpochMillisConverter
  - Format
    - Error
  - Kind
  - MonthSpan
  - Span
- Tuple
- TypeCastError
- UDPSocket
- UInt16
- UInt32
- UInt64
- UInt8
- Unicode
  - CaseOptions
- Union
- UNIXServer
- UNIXSocket
- URI
  - Error
- Value
- WeakRef
- XML
  - Attributes
  - AttributeType
  - Builder
  - Error
  - HTMLParserOptions
  - Namespace
  - Node
  - NodeSet
  - ParserOptions
  - Reader
  - SaveOptions
  - Type
  - XPathContext
- YAML
  - Any
  - Builder
  - Error
  - EventKind
  - ParseException
  - Parser
  - PullParser
  - Type
- Zip
  - CompressionMethod
  - Error
  - File
    - Entry
  - FileInfo
  - Reader
    - Entry
  - Writer
    - Entry
- Zlib
  - Error
  - Reader
  - Writer

# struct Range(B, E)

- Range(B, E)
- Struct
- Value
- Object

## Overview

A `Range` represents an interval: a set of values with a beginning and an end.

Ranges may be constructed using the usual `new` method or with literals:

    x..y  # an inclusive range, in mathematics: [x, y]
    x...y # an exclusive range, in mathematics: [x, y)

An easy way to remember which one is inclusive and which one is exclusive it to think of the extra dot as if it pushes y further away, thus leaving it outside of the range.

Ranges typically involve integers, but can be created using arbitrary objects as long as they define `succ` (or `pred` for `#reverse_each`), to get the next element in the range, and `<` and `==`, to know when the range reached the end:

    # Represents a string of 'x's.
    struct Xs
      include Comparable(Xs)

      getter size

      def initialize(@size : Int32)
      end

      def succ
        Xs.new(@size + 1)
      end

      def <=>(other)
        @size <=> other.size
      end

      def inspect(io)
        @size.times { io << 'x' }
      end

      def to_s(io)
        io << @size << ' '
        inspect(io)
      end
    end

An example of using `Xs` to construct a range:

    r = Xs.new(3)..Xs.new(6)
    r.to_s                 # => "xxx..xxxxxx"
    r.to_a                 # => [Xs.new(3), Xs.new(4), Xs.new(5), Xs.new(6)]
    r.includes?(Xs.new(5)) # => true

## Included Modules

- Enumerable(B)
- Iterable(B)

## Defined in:

## Constructors

- .new(begin : B, end : E, exclusive : Bool = false)

  Constructs a `Range` using the given beginning and end.

## Instance Method Summary

- #===(value)

  Same as `#includes?`, useful for the `case` expression.

- #begin : B

  Returns the object that defines the beginning of this range.

- #bsearch(&block)

  By using binary search, returns the first value for which the passed block returns `true`.

- #clone

  Returns a new `Range` with `#begin` and `#end` cloned.

- #covers?(value)

  Same as `#includes?`.

- #cycle

  Returns an `Iterator` that cycles over the values of this range.

- #each(&block) : Nil

  Iterates over the elements of this range, passing each in turn to the block.

- #each

  Returns an `Iterator` over the elements of this range.

- #end : E

  Returns the object that defines the end of the range.

- #excludes_end?

  Returns `true` if this range excludes the end element.

- #exclusive? : Bool

  Returns `true` if the range is exclusive.

- #includes?(value)

  Returns `true` if this range includes the given value.

- #reverse_each(&block) : Nil

  Iterates over the elements of this range in reverse order, passing each in turn to the block.

- #reverse_each

  Returns a reverse `Iterator` over the elements of this range.

- #step(by = 1)

  Returns an `Iterator` that returns each nth element in this range.

- #step(by = 1, &block)

  Iterates over this range, passing each nth element to the block.

- #sum(initial)

  If `self` is a `Int` range, it provides O(1) implementation, otherwise it is same as `Enumerable#sum`.

### Instance methods inherited from module `Iterable(B)`

chunk(reuse = false, &block : T -> U) forall U chunk, cycle(n)
cycle cycle, each each, each_cons(count : Int, reuse = false) each_cons, each_slice(count : Int, reuse = false) each_slice, each_with_index(offset = 0) each_with_index, each_with_object(obj) each_with_object

### Instance methods inherited from module `Enumerable(B)`

all?(&block)
all? all?, any?(&block)
any? any?, chunks(&block : T -> U) forall U chunks, compact_map(&block) compact_map, count(&block)
count(item) count, cycle(n, &block)
cycle(&block) cycle, each(&block : T -> _) each, each_cons(count : Int, reuse = false, &block) each_cons, each_slice(count : Int, reuse = false, &block) each_slice, each_with_index(offset = 0, &block) each_with_index, each_with_object(obj, &block) each_with_object, find(if_none = nil, &block) find, first(count : Int)
first first, first? first?, flat_map(&block : T -> Array(U) | Iterator(U) | U) forall U flat_map, grep(pattern) grep, group_by(&block : T -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &block) forall U in_groups_of, includes?(obj) includes?, index(&block)
index(obj) index, index_by(&block : T -> U) forall U index_by, join(separator, io)
join(separator = "")
join(separator, io, &block)
join(separator = "", &block) join, map(&block : T -> U) forall U map, map_with_index(&block : T, Int32 -> U) forall U map_with_index, max max, max? max?, max_by(&block : T -> U) forall U max_by, max_by?(&block : T -> U) forall U max_by?, max_of(&block : T -> U) forall U max_of, max_of?(&block : T -> U) forall U max_of?, min min, min? min?, min_by(&block : T -> U) forall U min_by, min_by?(&block : T -> U) forall U min_by?, min_of(&block : T -> U) forall U min_of, min_of?(&block : T -> U) forall U min_of?, minmax minmax, minmax? minmax?, minmax_by(&block : T -> U) forall U minmax_by, minmax_by?(&block : T -> U) forall U minmax_by?, minmax_of(&block : T -> U) forall U minmax_of, minmax_of?(&block : T -> U) forall U minmax_of?, none?(&block)
none? none?, one?(&block) one?, partition(&block) partition, product(&block)
product(initial : Number, &block)
product
product(initial : Number) product, reduce(&block)
reduce(memo, &block) reduce, reject(&block : T -> ) reject, select(&block : T -> ) select, size size, skip(count : Int) skip, skip_while(&block) skip_while, sum(initial)
sum
sum(initial, &block)
sum(&block) sum, take_while(&block) take_while, to_a to_a, to_h to_h, to_set to_set

### Instance methods inherited from struct `Struct`

==(other : self) : Bool ==, hash : Int32 hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io) to_s

### Instance methods inherited from struct `Value`

==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash hash, inspect(io : IO)
inspect inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s
to_s(io : IO) to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io) : self from_yaml

## Constructor Detail

def self.new(begin : B, end : E, exclusive : Bool = false) #

Constructs a `Range` using the given beginning and end.

    Range.new(1, 10)                  # => 1..10
    Range.new(1, 10, exclusive: true) # => 1...10

## Instance Method Detail

def ===(value) #

Same as `#includes?`, useful for the `case` expression.

    case 79
    when 1..50   then puts "low"
    when 51..75  then puts "medium"
    when 76..100 then puts "high"
    end

Produces:

    high

See also: `Object#===`.

def begin : B #

Returns the object that defines the beginning of this range.

    (1..10).begin  # => 1
    (1...10).begin # => 1

def bsearch(&block) #

By using binary search, returns the first value for which the passed block returns `true`.

If the block returns `false`, the finding value exists behind. If the block returns `true`, the finding value is itself or exists infront.

    (0..10).bsearch { |x| x >= 5 }                       # => 5
    (0..Float64::INFINITY).bsearch { |x| x ** 4 >= 256 } # => 4

Returns `nil` if the block didn't return `true` for any value.

def clone #

Returns a new `Range` with `#begin` and `#end` cloned.

def covers?(value) #

Same as `#includes?`.

def cycle #

Returns an `Iterator` that cycles over the values of this range.

    (1..3).cycle.first(5).to_a # => [1, 2, 3, 1, 2]

def each(&block) : Nil #

Iterates over the elements of this range, passing each in turn to the block.

    (10..15).each { |n| print n, ' ' }
    # prints: 10 11 12 13 14 15

def each #

Returns an `Iterator` over the elements of this range.

    (1..3).each.skip(1).to_a # => [2, 3]

def end : E #

Returns the object that defines the end of the range.

    (1..10).end  # => 10
    (1...10).end # => 10

def excludes_end? #

Returns `true` if this range excludes the end element.

    (1..10).excludes_end?  # => false
    (1...10).excludes_end? # => true

def exclusive? : Bool #

Returns `true` if the range is exclusive. Returns `false` otherwise (default).

def includes?(value) #

Returns `true` if this range includes the given value.

    (1..10).includes?(4)  # => true
    (1..10).includes?(10) # => true
    (1..10).includes?(11) # => false

    (1...10).includes?(9)  # => true
    (1...10).includes?(10) # => false

def reverse_each(&block) : Nil #

Iterates over the elements of this range in reverse order, passing each in turn to the block.

    (10...15).reverse_each { |n| print n, ' ' }
    # prints: 14 13 12 11 10

def reverse_each #

Returns a reverse `Iterator` over the elements of this range.

    (1..3).reverse_each.skip(1).to_a # => [2, 1]

def step(by = 1) #

Returns an `Iterator` that returns each nth element in this range.

    (1..10).step(3).skip(1).to_a # => [4, 7, 10]

def step(by = 1, &block) #

Iterates over this range, passing each nth element to the block.

    range = Xs.new(1)..Xs.new(10)
    range.step(2) { |x| puts x }
    puts
    range.step(3) { |x| puts x }

Produces:

    1 x
    3 xxx
    5 xxxxx
    7 xxxxxxx
    9 xxxxxxxxx

    1 x
    4 xxxx
    7 xxxxxxx
    10 xxxxxxxxxx

See `Range`'s overview for the definition of `Xs`.

def sum(initial) #

If `self` is a `Int` range, it provides O(1) implementation, otherwise it is same as `Enumerable#sum`.